package org.mandarax.xkb.framework;


/**
 *  Copyright (C) 1999-2004  Jens Dietrich (mailto:mandarax@jbdietrich.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.util.Map;

import org.jdom.Element;
import org.mandarax.kernel.LogicFactory;
import org.mandarax.kernel.Predicate;
import org.mandarax.sql.SQLClauseSet;
import org.mandarax.sql.SQLPredicate;
import org.mandarax.xkb.XKBException;
/**
 * An adapter class for sql clause sets.
 * @see org.mandarax.sql.SQLClauseSet
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 1.6 
 */

public class XMLAdapter4SQLClauseSets extends AbstractXMLAdapter {
      public static final String SQL_CLAUSE_SET = "sql_clause_set";
      public static final String WHERE = "where_clause";
      public static final String CACHE_TIMEOUT = "cache_timeout";

/**
 * Export a sql predicate, i.e., convert it to an element in the DOM.
 * @param obj an object
 * @param driver the generic driver
 * @param cache a cache used in order to associate the same
 * id with various occurences of the same object
 * @exception an XKBException is thrown if export fails
 */
public Element exportObject(Object obj,GenericDriver driver,Map cache) throws  XKBException {
      check(obj,SQLClauseSet.class);
      SQLClauseSet cs = (SQLClauseSet)obj;
      Element e = new Element(SQL_CLAUSE_SET);
      // add where and timeout
      if (cs.getWhereClause()!=null) e.setAttribute(WHERE,cs.getWhereClause());
      if (cs.getCacheTimeout()!=SQLClauseSet.NO_CACHE) e.setAttribute(CACHE_TIMEOUT,String.valueOf(cs.getCacheTimeout()));
      // add predicate
      Predicate p = cs.getPredicate();
      Element ep = exportObject(cs.getPredicate(),GenericDriver.SQL_PREDICATE,driver,cache);
      e.addContent(ep);
      return e;
}
/**
 * Build an object from an XML element.
 * @param e an element
 * @param driver the generic driver
 * @param cache a cache used to identify objects that have the same id
 * @param lfactory the logic factory used to create objects
 * @exception an XKBException is thrown if export fails
 */
public Object importObject(Element e,GenericDriver driver,Map cache,LogicFactory lfactory) throws XKBException {
      // get where clause
      String where = e.getAttributeValue(WHERE);
      // get timeout
      long timeout = SQLClauseSet.NO_CACHE;
      if (e.getAttribute(CACHE_TIMEOUT)!=null) {
            try {
                  timeout = Long.parseLong(e.getAttributeValue(CACHE_TIMEOUT));
            }
            catch (NumberFormatException x) {
                  throw new XKBException("Cannot read timeout");
            }
      }
      // get predicate
      SQLPredicate p = (SQLPredicate)importChild(e,GenericDriver.SQL_PREDICATE,driver,cache,lfactory);

      // build SQL clause set
      SQLClauseSet cs = new SQLClauseSet();
      cs.setSQLPredicate(p);
      cs.setWhereClause(where);
      cs.setCacheTimeout(timeout);
      return cs;

}
/**
 * Get the name of the associated tag (element).
 * @return a string
 */
public String getTagName() {
      return SQL_CLAUSE_SET;
}
/**
 * Get the kind of object the adapter can export/import.
 * @return a string
 */
public String getKindOfObject() {
      return GenericDriver.SQL_CLAUSE_SET;
}
}
